Skip to main content
PUT
/
public
/
v2
/
bills
/
{record_number}
/
Update Bill record
curl --request PUT \
  --url https://api.dualentry.com/public/v2/bills/{record_number}/ \
  --header 'Content-Type: application/json' \
  --header 'X-API-KEY: <api-key>' \
  --data '
{
  "date": "2023-12-25",
  "custom_fields": [
    {}
  ],
  "transaction_date": "2023-12-25",
  "company_id": 123,
  "vendor_id": 123,
  "exchange_rate": 123,
  "memo": "<string>",
  "items": [
    {
      "position": 123,
      "item_id": 123,
      "memo": "<string>",
      "rate": 123,
      "quantity": 123,
      "tax": {
        "code": "<string>",
        "rate": 123,
        "amount": 123,
        "is_taxable": true,
        "tax_exempt_amount": 123,
        "vat_rate_id": 123,
        "gst_tax_rate_id": 123
      },
      "id": 123,
      "classifications": [],
      "company_id": 123
    }
  ],
  "expenses": [
    {
      "position": 123,
      "rate": 123,
      "quantity": 123,
      "account_number": 123,
      "expense_description": "<string>",
      "tax": {
        "code": "<string>",
        "rate": 123,
        "amount": 123,
        "is_taxable": true,
        "tax_exempt_amount": 123,
        "vat_rate_id": 123,
        "gst_tax_rate_id": 123
      },
      "id": 123,
      "classifications": [],
      "customer_id": 123,
      "vendor_id": 123,
      "company_id": 123
    }
  ],
  "due_date": "2023-12-25",
  "term_id": 123,
  "reference_number": "",
  "purchase_order_number": 123,
  "attachments": [],
  "record_status": "posted"
}
'
import requests

url = "https://api.dualentry.com/public/v2/bills/{record_number}/"

payload = {
"date": "2023-12-25",
"custom_fields": [{}],
"transaction_date": "2023-12-25",
"company_id": 123,
"vendor_id": 123,
"exchange_rate": 123,
"memo": "<string>",
"items": [
{
"position": 123,
"item_id": 123,
"memo": "<string>",
"rate": 123,
"quantity": 123,
"tax": {
"code": "<string>",
"rate": 123,
"amount": 123,
"is_taxable": True,
"tax_exempt_amount": 123,
"vat_rate_id": 123,
"gst_tax_rate_id": 123
},
"id": 123,
"classifications": [],
"company_id": 123
}
],
"expenses": [
{
"position": 123,
"rate": 123,
"quantity": 123,
"account_number": 123,
"expense_description": "<string>",
"tax": {
"code": "<string>",
"rate": 123,
"amount": 123,
"is_taxable": True,
"tax_exempt_amount": 123,
"vat_rate_id": 123,
"gst_tax_rate_id": 123
},
"id": 123,
"classifications": [],
"customer_id": 123,
"vendor_id": 123,
"company_id": 123
}
],
"due_date": "2023-12-25",
"term_id": 123,
"reference_number": "",
"purchase_order_number": 123,
"attachments": [],
"record_status": "posted"
}
headers = {
"X-API-KEY": "<api-key>",
"Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.text)
const options = {
method: 'PUT',
headers: {'X-API-KEY': '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify({
date: '2023-12-25',
custom_fields: [{}],
transaction_date: '2023-12-25',
company_id: 123,
vendor_id: 123,
exchange_rate: 123,
memo: '<string>',
items: [
{
position: 123,
item_id: 123,
memo: '<string>',
rate: 123,
quantity: 123,
tax: {
code: '<string>',
rate: 123,
amount: 123,
is_taxable: true,
tax_exempt_amount: 123,
vat_rate_id: 123,
gst_tax_rate_id: 123
},
id: 123,
classifications: [],
company_id: 123
}
],
expenses: [
{
position: 123,
rate: 123,
quantity: 123,
account_number: 123,
expense_description: '<string>',
tax: {
code: '<string>',
rate: 123,
amount: 123,
is_taxable: true,
tax_exempt_amount: 123,
vat_rate_id: 123,
gst_tax_rate_id: 123
},
id: 123,
classifications: [],
customer_id: 123,
vendor_id: 123,
company_id: 123
}
],
due_date: '2023-12-25',
term_id: 123,
reference_number: '',
purchase_order_number: 123,
attachments: [],
record_status: 'posted'
})
};

fetch('https://api.dualentry.com/public/v2/bills/{record_number}/', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));


{
  "supply_date": "2023-12-25",
  "tax": {
    "data": {}
  },
  "transaction_ids": [
    123
  ],
  "term_id": 123,
  "term_name": "<string>",
  "internal_id": 123,
  "number": 123,
  "date": "2023-12-25",
  "transaction_date": "2023-12-25",
  "due_date": "2023-12-25",
  "company_id": 123,
  "company_name": "<string>",
  "company_currency": "<string>",
  "vendor_id": 123,
  "vendor_name": "<string>",
  "exchange_rate": "<string>",
  "memo": "<string>",
  "amount": "<string>",
  "amount_due": "<string>",
  "paid_total": "<string>",
  "items": [
    {
      "id": 123,
      "position": 123,
      "item_id": 123,
      "memo": "<string>",
      "rate": "<string>",
      "quantity": "<string>",
      "net_amount": "<string>",
      "tax_amount": "<string>",
      "gross_amount": "<string>",
      "amount": "<string>",
      "tax": {
        "code": "<string>",
        "rate": "<string>",
        "amount": "<string>",
        "is_taxable": true,
        "tax_exempt_amount": "<string>",
        "vat_rate_id": 123,
        "gst_tax_rate_id": 123,
        "tax_components": [
          {
            "rate": "<string>",
            "amount": "<string>",
            "position": 123,
            "region": "<string>"
          }
        ],
        "amount_with_tax": "<string>",
        "rate_name": "<string>",
        "rate_type": "<string>",
        "tax_treatment": "<string>"
      },
      "classifications": [],
      "company_id": 123,
      "item_type": "<string>",
      "hsn_sac_code": "<string>",
      "amortizable_assets": [],
      "fixed_assets": []
    }
  ],
  "expenses": [
    {
      "id": 123,
      "position": 123,
      "rate": "<string>",
      "quantity": "<string>",
      "account_number": 123,
      "expense_description": "<string>",
      "net_amount": "<string>",
      "tax_amount": "<string>",
      "gross_amount": "<string>",
      "amount": "<string>",
      "tax": {
        "code": "<string>",
        "rate": "<string>",
        "amount": "<string>",
        "is_taxable": true,
        "tax_exempt_amount": "<string>",
        "vat_rate_id": 123,
        "gst_tax_rate_id": 123,
        "tax_components": [
          {
            "rate": "<string>",
            "amount": "<string>",
            "position": 123,
            "region": "<string>"
          }
        ],
        "amount_with_tax": "<string>",
        "rate_name": "<string>",
        "rate_type": "<string>",
        "tax_treatment": "<string>"
      },
      "classifications": [],
      "customer_id": 123,
      "vendor_id": 123,
      "company_id": 123,
      "amortizable_assets": [],
      "fixed_assets": [],
      "customer_name": "<string>",
      "vendor_name": "<string>"
    }
  ],
  "recurring_record_number": 123,
  "purchase_order_number": 123,
  "reference_number": "<string>",
  "created_at": "2023-11-07T05:31:56Z",
  "updated_at": "2023-11-07T05:31:56Z",
  "custom_fields": [],
  "place_of_supply": "<string>",
  "tax_registration_numbers": {
    "company": [
      {
        "type": "<string>",
        "number": "<string>",
        "region": "<string>"
      }
    ],
    "counterparty": [
      {
        "type": "<string>",
        "number": "<string>",
        "region": "<string>"
      }
    ]
  },
  "attachments": [],
  "bank_match_status": "<string>",
  "reconciliation_status": "<string>",
  "created_by": {
    "actor_type": "<string>",
    "email": "<string>",
    "first_name": "<string>",
    "last_name": "<string>",
    "timestamp": "2023-11-07T05:31:56Z"
  },
  "updated_by": {
    "actor_type": "<string>",
    "email": "<string>",
    "first_name": "<string>",
    "last_name": "<string>",
    "timestamp": "2023-11-07T05:31:56Z"
  },
  "approval_status": "<string>",
  "next_approvers": [
    {
      "id": 123,
      "first_name": "<string>",
      "last_name": "<string>",
      "email": "<string>",
      "full_name": "<string>",
      "avatar_url": "<string>"
    }
  ],
  "rejected_by": {
    "id": 123,
    "first_name": "<string>",
    "last_name": "<string>",
    "email": "<string>",
    "full_name": "<string>",
    "rejection_reason": "<string>"
  }
}
{
"errors": {},
"success": false
}
{
"errors": {},
"success": false
}
{
"errors": {},
"success": false
}
{
"errors": {},
"success": false
}

Authorizations

X-API-KEY
string
header
required

Path Parameters

record_number
integer
required

The number attribute of the record.

Body

application/json
date
string<date>
required
custom_fields
Custom Fields · object[] | null
transaction_date
string<date> | null
company_id
integer | null
vendor_id
integer | null
currency_iso_4217_code
enum<string> | null
Available options:
AED,
AFN,
ALL,
AMD,
ANG,
AOA,
ARS,
AUD,
AWG,
AZN,
BAM,
BBD,
BDT,
BGN,
BHD,
BIF,
BMD,
BND,
BOB,
BRL,
BSD,
BTN,
BWP,
BYN,
BZD,
CAD,
CDF,
CHF,
CLF,
CLP,
CNY,
COP,
CRC,
CUP,
CVE,
CZK,
DJF,
DKK,
DOP,
DZD,
EGP,
ERN,
ETB,
EUR,
FJD,
FKP,
GBP,
GEL,
GHS,
GIP,
GMD,
GNF,
GTQ,
GYD,
HKD,
HNL,
HTG,
HUF,
IDR,
ILS,
INR,
IQD,
IRR,
ISK,
JMD,
JOD,
JPY,
KES,
KGS,
KHR,
KMF,
KPW,
KRW,
KWD,
KYD,
KZT,
LAK,
LBP,
LKR,
LRD,
LSL,
LYD,
MAD,
MDL,
MGA,
MKD,
MMK,
MNT,
MOP,
MRU,
MUR,
MVR,
MWK,
MXN,
MYR,
MZN,
NAD,
NGN,
NIO,
NOK,
NPR,
NZD,
OMR,
PAB,
PEN,
PGK,
PHP,
PKR,
PLN,
PYG,
QAR,
RON,
RSD,
RUB,
RWF,
SAR,
SBD,
SCR,
SDG,
SEK,
SGD,
SHP,
SLL,
SOS,
SRD,
STN,
SVC,
SYP,
SZL,
THB,
TJS,
TMT,
TND,
TOP,
TRY,
TTD,
TWD,
TZS,
UAH,
UGX,
USD,
UYU,
UZS,
VES,
VND,
VUV,
WST,
XAF,
XAG,
XAU,
XCD,
XDR,
XOF,
XPD,
XPF,
XPT,
YER,
ZAR,
ZMW,
ZWL
exchange_rate
memo
string | null
items
PublicBillItemIn · object[] | null
expenses
PublicBillExpenseIn · object[] | null
due_date
string<date> | null
term_id
integer | null
reference_number
string
default:""
purchase_order_number
integer | null
attachments
AttachmentSchemaOut · object[]
record_status
enum<string>
default:posted
Available options:
draft,
posted,
archived

Response

OK

supply_date
string<date> | null
required
tax
RecordTaxContextOut · object | null
required

Base for record-level tax context; regime discriminates data.

Mirrors TaxResultV2Out (core.taxes.api.taxes)

transaction_ids
integer[]
required
term_id
integer | null
required
term_name
string
required
internal_id
integer
required
number
integer
required
date
string<date>
required

Posting date (GL date) - the date when the transaction is recorded in the general ledger

transaction_date
string<date>
required

Transaction date (inception date) - the date when the transaction actually occurred

due_date
string<date>
required
company_id
integer
required
company_name
string
required
company_currency
string
required
vendor_id
integer
required
vendor_name
string
required
currency_iso_4217_code
enum<string>
required
Available options:
AED,
AFN,
ALL,
AMD,
ANG,
AOA,
ARS,
AUD,
AWG,
AZN,
BAM,
BBD,
BDT,
BGN,
BHD,
BIF,
BMD,
BND,
BOB,
BRL,
BSD,
BTN,
BWP,
BYN,
BZD,
CAD,
CDF,
CHF,
CLF,
CLP,
CNY,
COP,
CRC,
CUP,
CVE,
CZK,
DJF,
DKK,
DOP,
DZD,
EGP,
ERN,
ETB,
EUR,
FJD,
FKP,
GBP,
GEL,
GHS,
GIP,
GMD,
GNF,
GTQ,
GYD,
HKD,
HNL,
HTG,
HUF,
IDR,
ILS,
INR,
IQD,
IRR,
ISK,
JMD,
JOD,
JPY,
KES,
KGS,
KHR,
KMF,
KPW,
KRW,
KWD,
KYD,
KZT,
LAK,
LBP,
LKR,
LRD,
LSL,
LYD,
MAD,
MDL,
MGA,
MKD,
MMK,
MNT,
MOP,
MRU,
MUR,
MVR,
MWK,
MXN,
MYR,
MZN,
NAD,
NGN,
NIO,
NOK,
NPR,
NZD,
OMR,
PAB,
PEN,
PGK,
PHP,
PKR,
PLN,
PYG,
QAR,
RON,
RSD,
RUB,
RWF,
SAR,
SBD,
SCR,
SDG,
SEK,
SGD,
SHP,
SLL,
SOS,
SRD,
STN,
SVC,
SYP,
SZL,
THB,
TJS,
TMT,
TND,
TOP,
TRY,
TTD,
TWD,
TZS,
UAH,
UGX,
USD,
UYU,
UZS,
VES,
VND,
VUV,
WST,
XAF,
XAG,
XAU,
XCD,
XDR,
XOF,
XPD,
XPF,
XPT,
YER,
ZAR,
ZMW,
ZWL
exchange_rate
string
required
Pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d{0,16}0*$
memo
string
required
amount
string
required

Total amount of transaction

Pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d{0,2}0*$
amount_due
string
required

Amount to be paid

Pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d{0,2}0*$
paid_total
string
required

Amount that was already paid by Vendor Prepayment Applications or Vendor Payments

Pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d{0,2}0*$
items
PublicBillItemOut · object[]
required
expenses
PublicBillExpenseOut · object[]
required
record_status
enum<string>
required
Available options:
draft,
posted,
archived
recurring_record_number
integer | null
required
purchase_order_number
integer | null
required
reference_number
string
required
created_at
string<date-time>
required

Date and time the record was created

updated_at
string<date-time>
required

Date and time the record was last updated

custom_fields
CustomFieldValuePairOutputSchema · object[]
place_of_supply
string | null
Maximum string length: 2
tax_registration_numbers
TaxRegistrationNumbersSnapshot · object | null
attachments
PublicAttachmentSchemaOut · object[]
bank_match_status
string | null
reconciliation_status
string | null
created_by
AuditActorSchemaOut · object | null

Schema for audit actor information.

updated_by
AuditActorSchemaOut · object | null

Schema for audit actor information.

approval_status
string | null
next_approvers
ApproverDictSchema · object[] | null
rejected_by
RejectedBySchema · object | null

Schema for rejector information including rejection reason.

Last modified on July 13, 2026